芝麻web文件管理V1.00
编辑当前文件:/home/conskgoa/doughi.co.uk/node-fetch-npm.tar
CHANGELOG.md 0000644 00000020074 15220056450 0006357 0 ustar 00 # Change Log All notable changes to this project will be documented in this file. See [standard-version](https://github.com/conventional-changelog/standard-version) for commit guidelines.
## [2.0.2](https://github.com/npm/node-fetch-npm/compare/v2.0.1...v2.0.2) (2017-08-15) ### Bug Fixes * **json:** replace jju with a custom syntax error reporter ([#6](https://github.com/npm/node-fetch-npm/issues/6)) ([84d169c](https://github.com/npm/node-fetch-npm/commit/84d169c))
## [2.0.1](https://github.com/npm/node-fetch-npm/compare/v2.0.0...v2.0.1) (2017-05-24) ### Bug Fixes * **json:** improve JSON parse error reporting ([1c810df](https://github.com/npm/node-fetch-npm/commit/1c810df))
# [2.0.0](https://github.com/npm/node-fetch-npm/compare/v1.0.1...v2.0.0) (2017-05-06) ### Features * **version:** force bump to 2.0 ([39c5d50](https://github.com/npm/node-fetch-npm/commit/39c5d50)) ### BREAKING CHANGES * **version:** tooling got confused, so hitting 2.0.0 for reals now
## [1.0.1](https://github.com/npm/node-fetch-npm/compare/v1.0.0...v1.0.1) (2017-05-06) ### Bug Fixes * **redirect:** Remove authorization header on redirect to different host ([#2](https://github.com/npm/node-fetch-npm/issues/2)) ([273260e](https://github.com/npm/node-fetch-npm/commit/273260e))
# [1.0.0](https://github.com/npm/node-fetch-npm/compare/v2.0.0-alpha.3...v1.0.0) (2017-04-26) ### Bug Fixes * **proj:** initial fork changes ([0a190a8](https://github.com/npm/node-fetch-npm/commit/0a190a8)) ### BREAKING CHANGES * **proj:** this renames the library altogether Changelog ========= # 2.x release ## v2.0.0 This is a major release. Check [our upgrade guide](https://github.com/bitinn/node-fetch/blob/master/UPGRADE-GUIDE.md) for an overview on some key differences between v1 and v2. ### General changes - Major: Node.js 0.10.x and 0.12.x support is dropped - Major: `require('node-fetch/lib/response')` etc. is now unsupported; use `require('node-fetch').Response` or ES6 module imports - Enhance: start testing on Node.js 4, 6, 7 - Enhance: use Rollup to produce a distributed bundle (less memory overhead and faster startup) - Enhance: make `Object.prototype.toString()` on Headers, Requests, and Responses return correct class strings - Other: rewrite in ES2015 using Babel - Other: use Codecov for code coverage tracking ### HTTP requests - Major: overwrite user's `Content-Length` if we can be sure our information is correct (per spec) - Fix: support WHATWG URL objects, created by `whatwg-url` package or `require('url').URL` in Node.js 7+ ### Response and Request classes - Major: `response.text()` no longer attempts to detect encoding, instead always opting for UTF-8 (per spec); use `response.textConverted()` for the v1 behavior - Major: make `response.json()` throw error instead of returning an empty object on 204 no-content respose (per spec; reverts behavior changed in v1.6.2) - Major: internal methods are no longer exposed - Major: throw error when a `GET` or `HEAD` Request is constructed with a non-null body (per spec) - Enhance: add `response.arrayBuffer()` (also applies to Requests) - Enhance: add experimental `response.blob()` (also applies to Requests) - Fix: fix Request and Response with `null` body ### Headers class - Major: remove `headers.getAll()`; make `get()` return all headers delimited by commas (per spec) - Enhance: make Headers iterable - Enhance: make Headers constructor accept an array of tuples - Enhance: make sure header names and values are valid in HTTP - Fix: coerce Headers prototype function parameters to strings, where applicable ### Documentation - Enhance: more comprehensive API docs - Enhance: add a list of default headers in README # 1.x release ## v1.6.3 - Enhance: error handling document to explain `FetchError` design - Fix: support `form-data` 2.x releases (requires `form-data` >= 2.1.0) ## v1.6.2 - Enhance: minor document update - Fix: response.json() returns empty object on 204 no-content response instead of throwing a syntax error ## v1.6.1 - Fix: if `res.body` is a non-stream non-formdata object, we will call `body.toString` and send it as a string - Fix: `counter` value is incorrectly set to `follow` value when wrapping Request instance - Fix: documentation update ## v1.6.0 - Enhance: added `res.buffer()` api for convenience, it returns body as a Node.js buffer - Enhance: better old server support by handling raw deflate response - Enhance: skip encoding detection for non-HTML/XML response - Enhance: minor document update - Fix: HEAD request doesn't need decompression, as body is empty - Fix: `req.body` now accepts a Node.js buffer ## v1.5.3 - Fix: handle 204 and 304 responses when body is empty but content-encoding is gzip/deflate - Fix: allow resolving response and cloned response in any order - Fix: avoid setting `content-length` when `form-data` body use streams - Fix: send DELETE request with content-length when body is present - Fix: allow any url when calling new Request, but still reject non-http(s) url in fetch ## v1.5.2 - Fix: allow node.js core to handle keep-alive connection pool when passing a custom agent ## v1.5.1 - Fix: redirect mode `manual` should work even when there is no redirection or broken redirection ## v1.5.0 - Enhance: rejected promise now use custom `Error` (thx to @pekeler) - Enhance: `FetchError` contains `err.type` and `err.code`, allows for better error handling (thx to @pekeler) - Enhance: basic support for redirect mode `manual` and `error`, allows for location header extraction (thx to @jimmywarting for the initial PR) ## v1.4.1 - Fix: wrapping Request instance with FormData body again should preserve the body as-is ## v1.4.0 - Enhance: Request and Response now have `clone` method (thx to @kirill-konshin for the initial PR) - Enhance: Request and Response now have proper string and buffer body support (thx to @kirill-konshin) - Enhance: Body constructor has been refactored out (thx to @kirill-konshin) - Enhance: Headers now has `forEach` method (thx to @tricoder42) - Enhance: back to 100% code coverage - Fix: better form-data support (thx to @item4) - Fix: better character encoding detection under chunked encoding (thx to @dsuket for the initial PR) ## v1.3.3 - Fix: make sure `Content-Length` header is set when body is string for POST/PUT/PATCH requests - Fix: handle body stream error, for cases such as incorrect `Content-Encoding` header - Fix: when following certain redirects, use `GET` on subsequent request per Fetch Spec - Fix: `Request` and `Response` constructors now parse headers input using `Headers` ## v1.3.2 - Enhance: allow auto detect of form-data input (no `FormData` spec on node.js, this is form-data specific feature) ## v1.3.1 - Enhance: allow custom host header to be set (server-side only feature, as it's a forbidden header on client-side) ## v1.3.0 - Enhance: now `fetch.Request` is exposed as well ## v1.2.1 - Enhance: `Headers` now normalized `Number` value to `String`, prevent common mistakes ## v1.2.0 - Enhance: now fetch.Headers and fetch.Response are exposed, making testing easier ## v1.1.2 - Fix: `Headers` should only support `String` and `Array` properties, and ignore others ## v1.1.1 - Enhance: now req.headers accept both plain object and `Headers` instance ## v1.1.0 - Enhance: timeout now also applies to response body (in case of slow response) - Fix: timeout is now cleared properly when fetch is done/has failed ## v1.0.6 - Fix: less greedy content-type charset matching ## v1.0.5 - Fix: when `follow = 0`, fetch should not follow redirect - Enhance: update tests for better coverage - Enhance: code formatting - Enhance: clean up doc ## v1.0.4 - Enhance: test iojs support - Enhance: timeout attached to socket event only fire once per redirect ## v1.0.3 - Fix: response size limit should reject large chunk - Enhance: added character encoding detection for xml, such as rss/atom feed (encoding in DTD) ## v1.0.2 - Fix: added res.ok per spec change ## v1.0.0 - Enhance: better test coverage and doc # 0.x release ## v0.1 - Major: initial public release LICENSE.md 0000644 00000002067 15220056450 0006154 0 ustar 00 The MIT License (MIT) Copyright (c) 2016 David Frank Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. README.md 0000644 00000030644 15220056450 0006031 0 ustar 00 node-fetch-npm ============== [![npm version][npm-image]][npm-url] [![build status][travis-image]][travis-url] [![coverage status][codecov-image]][codecov-url] A light-weight module that brings `window.fetch` to Node.js `node-fetch-npm` is a fork of [`node-fetch`](https://npm.im/node-fetch) used in npm itself, through [`make-fetch-happen`](https://npm.im/make-fetch-happen). It has more regular releases and accepts some patches that would not fit with `node-fetch`'s own design goals (such as picking a specific cookie library, removing `babel` dependency altogether, etc). This library is *not a replacement* for `node-fetch`, nor does it intend to supplant it. It's purely a fork maintained for the sake of easier patching of specific needs that it wouldn't be fair to shove down the main project's throat. This project will still send patches for shared bugs over and hopefully help improve its "parent". ## Motivation Instead of implementing `XMLHttpRequest` in Node.js to run browser-specific [Fetch polyfill](https://github.com/github/fetch), why not go from native `http` to `fetch` API directly? Hence `node-fetch`, minimal code for a `window.fetch` compatible API on Node.js runtime. See Matt Andrews' [isomorphic-fetch](https://github.com/matthew-andrews/isomorphic-fetch) for isomorphic usage (exports `node-fetch` for server-side, `whatwg-fetch` for client-side). ## Features - Stay consistent with `window.fetch` API. - Make conscious trade-off when following [whatwg fetch spec][whatwg-fetch] and [stream spec](https://streams.spec.whatwg.org/) implementation details, document known difference. - Use native promise, but allow substituting it with [insert your favorite promise library]. - Use native stream for body, on both request and response. - Decode content encoding (gzip/deflate) properly, and convert string output (such as `res.text()` and `res.json()`) to UTF-8 automatically. - Useful extensions such as timeout, redirect limit, response size limit, [explicit errors][] for troubleshooting. ## Difference from client-side fetch - See [Known Differences](https://github.com/npm/node-fetch-npm/blob/master/LIMITS.md) for details. - If you happen to use a missing feature that `window.fetch` offers, feel free to open an issue. - Pull requests are welcomed too! ## Install ```sh $ npm install node-fetch-npm --save ``` ## Usage ```javascript import fetch from 'node-fetch'; // or // const fetch = require('node-fetch'); // if you are using your own Promise library, set it through fetch.Promise. Eg. // import Bluebird from 'bluebird'; // fetch.Promise = Bluebird; // plain text or html fetch('https://github.com/') .then(res => res.text()) .then(body => console.log(body)); // json fetch('https://api.github.com/users/github') .then(res => res.json()) .then(json => console.log(json)); // catching network error // 3xx-5xx responses are NOT network errors, and should be handled in then() // you only need one catch() at the end of your promise chain fetch('http://domain.invalid/') .catch(err => console.error(err)); // stream // the node.js way is to use stream when possible fetch('https://assets-cdn.github.com/images/modules/logos_page/Octocat.png') .then(res => { const dest = fs.createWriteStream('./octocat.png'); res.body.pipe(dest); }); // buffer // if you prefer to cache binary data in full, use buffer() // note that buffer() is a node-fetch only API import fileType from 'file-type'; fetch('https://assets-cdn.github.com/images/modules/logos_page/Octocat.png') .then(res => res.buffer()) .then(buffer => fileType(buffer)) .then(type => { /* ... */ }); // meta fetch('https://github.com/') .then(res => { console.log(res.ok); console.log(res.status); console.log(res.statusText); console.log(res.headers.raw()); console.log(res.headers.get('content-type')); }); // post fetch('http://httpbin.org/post', { method: 'POST', body: 'a=1' }) .then(res => res.json()) .then(json => console.log(json)); // post with stream from file import { createReadStream } from 'fs'; const stream = createReadStream('input.txt'); fetch('http://httpbin.org/post', { method: 'POST', body: stream }) .then(res => res.json()) .then(json => console.log(json)); // post with JSON var body = { a: 1 }; fetch('http://httpbin.org/post', { method: 'POST', body: JSON.stringify(body), headers: { 'Content-Type': 'application/json' }, }) .then(res => res.json()) .then(json => console.log(json)); // post with form-data (detect multipart) import FormData from 'form-data'; const form = new FormData(); form.append('a', 1); fetch('http://httpbin.org/post', { method: 'POST', body: form }) .then(res => res.json()) .then(json => console.log(json)); // post with form-data (custom headers) // note that getHeaders() is non-standard API import FormData from 'form-data'; const form = new FormData(); form.append('a', 1); fetch('http://httpbin.org/post', { method: 'POST', body: form, headers: form.getHeaders() }) .then(res => res.json()) .then(json => console.log(json)); // node 7+ with async function (async function () { const res = await fetch('https://api.github.com/users/github'); const json = await res.json(); console.log(json); })(); ``` See [test cases](https://github.com/npm/node-fetch-npm/blob/master/test/test.js) for more examples. ## API ### fetch(url[, options]) - `url` A string representing the URL for fetching - `options` [Options](#fetch-options) for the HTTP(S) request - Returns:
Promise<[Response](#class-response)>
Perform an HTTP(S) fetch. `url` should be an absolute url, such as `http://example.com/`. A path-relative URL (`/file/under/root`) or protocol-relative URL (`//can-be-http-or-https.com/`) will result in a rejected promise.
#### Options The default values are shown after each option key. ```js { // These properties are part of the Fetch Standard method: 'GET', headers: {}, // request headers. format is the identical to that accepted by the Headers constructor (see below) body: null, // request body. can be null, a string, a Buffer, a Blob, or a Node.js Readable stream redirect: 'follow', // set to `manual` to extract redirect headers, `error` to reject redirect // The following properties are node-fetch-npm extensions follow: 20, // maximum redirect count. 0 to not follow redirect timeout: 0, // req/res timeout in ms, it resets on redirect. 0 to disable (OS limit applies) compress: true, // support gzip/deflate content encoding. false to disable size: 0, // maximum response body size in bytes. 0 to disable agent: null // http(s).Agent instance, allows custom proxy, certificate etc. } ``` ##### Default Headers If no values are set, the following request headers will be sent automatically: Header | Value ----------------- | -------------------------------------------------------- `Accept-Encoding` | `gzip,deflate` _(when `options.compress === true`)_ `Accept` | `*/*` `Connection` | `close` _(when no `options.agent` is present)_ `Content-Length` | _(automatically calculated, if possible)_ `User-Agent` | `node-fetch-npm/1.0 (+https://github.com/npm/node-fetch-npm)`
### Class: Request An HTTP(S) request containing information about URL, method, headers, and the body. This class implements the [Body](#iface-body) interface. Due to the nature of Node.js, the following properties are not implemented at this moment: - `type` - `destination` - `referrer` - `referrerPolicy` - `mode` - `credentials` - `cache` - `integrity` - `keepalive` The following node-fetch-npm extension properties are provided: - `follow` - `compress` - `counter` - `agent` See [options](#fetch-options) for exact meaning of these extensions. #### new Request(input[, options])
*(spec-compliant)*
- `input` A string representing a URL, or another `Request` (which will be cloned) - `options` [Options][#fetch-options] for the HTTP(S) request Constructs a new `Request` object. The constructor is identical to that in the [browser](https://developer.mozilla.org/en-US/docs/Web/API/Request/Request). In most cases, directly `fetch(url, options)` is simpler than creating a `Request` object.
### Class: Response An HTTP(S) response. This class implements the [Body](#iface-body) interface. The following properties are not implemented in node-fetch-npm at this moment: - `Response.error()` - `Response.redirect()` - `type` - `redirected` - `trailer` #### new Response([body[, options]])
*(spec-compliant)*
- `body` A string or [Readable stream][node-readable] - `options` A [`ResponseInit`][response-init] options dictionary Constructs a new `Response` object. The constructor is identical to that in the [browser](https://developer.mozilla.org/en-US/docs/Web/API/Response/Response). Because Node.js does not implement service workers (for which this class was designed), one rarely has to construct a `Response` directly.
### Class: Headers This class allows manipulating and iterating over a set of HTTP headers. All methods specified in the [Fetch Standard][whatwg-fetch] are implemented. #### new Headers([init])
*(spec-compliant)*
- `init` Optional argument to pre-fill the `Headers` object Construct a new `Headers` object. `init` can be either `null`, a `Headers` object, an key-value map object, or any iterable object. ```js // Example adapted from https://fetch.spec.whatwg.org/#example-headers-class const meta = { 'Content-Type': 'text/xml', 'Breaking-Bad': '<3' }; const headers = new Headers(meta); // The above is equivalent to const meta = [ [ 'Content-Type', 'text/xml' ], [ 'Breaking-Bad', '<3' ] ]; const headers = new Headers(meta); // You can in fact use any iterable objects, like a Map or even another Headers const meta = new Map(); meta.set('Content-Type', 'text/xml'); meta.set('Breaking-Bad', '<3'); const headers = new Headers(meta); const copyOfHeaders = new Headers(headers); ```
### Interface: Body `Body` is an abstract interface with methods that are applicable to both `Request` and `Response` classes. The following methods are not yet implemented in node-fetch-npm at this moment: - `formData()` #### body.body
*(deviation from spec)*
* Node.js [`Readable` stream][node-readable] The data encapsulated in the `Body` object. Note that while the [Fetch Standard][whatwg-fetch] requires the property to always be a WHATWG `ReadableStream`, in node-fetch-npm it is a Node.js [`Readable` stream][node-readable]. #### body.bodyUsed
*(spec-compliant)*
* `Boolean` A boolean property for if this body has been consumed. Per spec, a consumed body cannot be used again. #### body.arrayBuffer() #### body.blob() #### body.json() #### body.text()
*(spec-compliant)*
* Returns:
Promise
Consume the body and return a promise that will resolve to one of these formats. #### body.buffer()
*(node-fetch-npm extension)*
* Returns:
Promise<Buffer>
Consume the body and return a promise that will resolve to a Buffer. #### body.textConverted()
*(node-fetch-npm extension)*
* Returns:
Promise<String>
Identical to `body.text()`, except instead of always converting to UTF-8, encoding sniffing will be performed and text converted to UTF-8, if possible.
### Class: FetchError
*(node-fetch-npm extension)*
An operational error in the fetching process. See [ERROR-HANDLING.md][] for more info. ## License MIT ## Acknowledgement Thanks to [github/fetch](https://github.com/github/fetch) for providing a solid implementation reference. [npm-image]: https://img.shields.io/npm/v/node-fetch-npm.svg?style=flat-square [npm-url]: https://www.npmjs.com/package/node-fetch-npm [travis-image]: https://img.shields.io/travis/npm/node-fetch-npm.svg?style=flat-square [travis-url]: https://travis-ci.org/npm/node-fetch-npm [codecov-image]: https://img.shields.io/codecov/c/github/npm/node-fetch-npm.svg?style=flat-square [codecov-url]: https://codecov.io/gh/npm/node-fetch-npm [ERROR-HANDLING.md]: https://github.com/npm/node-fetch-npm/blob/master/ERROR-HANDLING.md [whatwg-fetch]: https://fetch.spec.whatwg.org/ [response-init]: https://fetch.spec.whatwg.org/#responseinit [node-readable]: https://nodejs.org/api/stream.html#stream_readable_streams [mdn-headers]: https://developer.mozilla.org/en-US/docs/Web/API/Headers src/body.js 0000644 00000023064 15220056450 0006632 0 ustar 00 'use strict' /** * body.js * * Body interface provides common methods for Request and Response */ const Buffer = require('safe-buffer').Buffer const Blob = require('./blob.js') const BUFFER = Blob.BUFFER const convert = require('encoding').convert const parseJson = require('json-parse-better-errors') const FetchError = require('./fetch-error.js') const Stream = require('stream') const PassThrough = Stream.PassThrough const DISTURBED = Symbol('disturbed') /** * Body class * * Cannot use ES6 class because Body must be called with .call(). * * @param Stream body Readable stream * @param Object opts Response options * @return Void */ exports = module.exports = Body function Body (body, opts) { if (!opts) opts = {} const size = opts.size == null ? 0 : opts.size const timeout = opts.timeout == null ? 0 : opts.timeout if (body == null) { // body is undefined or null body = null } else if (typeof body === 'string') { // body is string } else if (body instanceof Blob) { // body is blob } else if (Buffer.isBuffer(body)) { // body is buffer } else if (body instanceof Stream) { // body is stream } else { // none of the above // coerce to string body = String(body) } this.body = body this[DISTURBED] = false this.size = size this.timeout = timeout } Body.prototype = { get bodyUsed () { return this[DISTURBED] }, /** * Decode response as ArrayBuffer * * @return Promise */ arrayBuffer () { return consumeBody.call(this).then(buf => buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength)) }, /** * Return raw response as Blob * * @return Promise */ blob () { let ct = (this.headers && this.headers.get('content-type')) || '' return consumeBody.call(this).then(buf => Object.assign( // Prevent copying new Blob([], { type: ct.toLowerCase() }), { [BUFFER]: buf } )) }, /** * Decode response as json * * @return Promise */ json () { return consumeBody.call(this).then(buffer => parseJson(buffer.toString())) }, /** * Decode response as text * * @return Promise */ text () { return consumeBody.call(this).then(buffer => buffer.toString()) }, /** * Decode response as buffer (non-spec api) * * @return Promise */ buffer () { return consumeBody.call(this) }, /** * Decode response as text, while automatically detecting the encoding and * trying to decode to UTF-8 (non-spec api) * * @return Promise */ textConverted () { return consumeBody.call(this).then(buffer => convertBody(buffer, this.headers)) } } Body.mixIn = function (proto) { for (const name of Object.getOwnPropertyNames(Body.prototype)) { // istanbul ignore else: future proof if (!(name in proto)) { const desc = Object.getOwnPropertyDescriptor(Body.prototype, name) Object.defineProperty(proto, name, desc) } } } /** * Decode buffers into utf-8 string * * @return Promise */ function consumeBody (body) { if (this[DISTURBED]) { return Body.Promise.reject(new Error(`body used already for: ${this.url}`)) } this[DISTURBED] = true // body is null if (this.body === null) { return Body.Promise.resolve(Buffer.alloc(0)) } // body is string if (typeof this.body === 'string') { return Body.Promise.resolve(Buffer.from(this.body)) } // body is blob if (this.body instanceof Blob) { return Body.Promise.resolve(this.body[BUFFER]) } // body is buffer if (Buffer.isBuffer(this.body)) { return Body.Promise.resolve(this.body) } // istanbul ignore if: should never happen if (!(this.body instanceof Stream)) { return Body.Promise.resolve(Buffer.alloc(0)) } // body is stream // get ready to actually consume the body let accum = [] let accumBytes = 0 let abort = false return new Body.Promise((resolve, reject) => { let resTimeout // allow timeout on slow response body if (this.timeout) { resTimeout = setTimeout(() => { abort = true reject(new FetchError(`Response timeout while trying to fetch ${this.url} (over ${this.timeout}ms)`, 'body-timeout')) }, this.timeout) } // handle stream error, such as incorrect content-encoding this.body.on('error', err => { reject(new FetchError(`Invalid response body while trying to fetch ${this.url}: ${err.message}`, 'system', err)) }) this.body.on('data', chunk => { if (abort || chunk === null) { return } if (this.size && accumBytes + chunk.length > this.size) { abort = true reject(new FetchError(`content size at ${this.url} over limit: ${this.size}`, 'max-size')) return } accumBytes += chunk.length accum.push(chunk) }) this.body.on('end', () => { if (abort) { return } clearTimeout(resTimeout) resolve(Buffer.concat(accum)) }) }) } /** * Detect buffer encoding and convert to target encoding * ref: http://www.w3.org/TR/2011/WD-html5-20110113/parsing.html#determining-the-character-encoding * * @param Buffer buffer Incoming buffer * @param String encoding Target encoding * @return String */ function convertBody (buffer, headers) { const ct = headers.get('content-type') let charset = 'utf-8' let res, str // header if (ct) { res = /charset=([^;]*)/i.exec(ct) } // no charset in content type, peek at response body for at most 1024 bytes str = buffer.slice(0, 1024).toString() // html5 if (!res && str) { res = /